<?php

namespace KayStrobach\Lightroom\ViewHelpers;

use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractTagBasedViewHelper;
use TYPO3\CMS\Core\Resource\ProcessedFile;
use \TYPO3\CMS\Core\Resource\File;

/**
 * Class ThumbnailViewhelper
 * @package KayStrobach\Lightroom\ViewHelpers
 */
class ThumbnailViewHelper extends AbstractTagBasedViewHelper
{
    protected $tagName = 'img';

    public function initializeArguments()
    {
        parent::initializeArguments(); // TODO: Change the autogenerated stub
        $this->registerArgument('image', File::class, 'Image file', true);
        $this->registerArgument('size', 'integer', 'dimensions of the image', true);
    }

    /**
     * @param File $image
     * @param integer $size
     * @return string
     */
    public function render()
    {
        $processedFile = $this->arguments['image']->process(
            ProcessedFile::CONTEXT_IMAGEPREVIEW,
            [
                'width' => $this->arguments['size'],
                'height' => $this->arguments['size']
            ]
        );

        $this->tag->addAttribute(
            'src',
            $processedFile->getPublicUrl(true)
        );
        return $this->tag->render();
    }
}
